/*********************************************************************\
 *                          StripANSI v1.0                           *
 * 								     *
 *                      Intuition Full Version                       *
 *                                                                   *
 *                     Written by Syd L. Bolton                      *
 *         Copyright 1991 Legendary Design Technologies Inc.        *
 *                                                                   *
 *        Revision: 001  Date: August 3, 1991  Time: 10:57:24        *
\*********************************************************************/

#include <exec/memory.h>
#include <stdio.h>
#include <intuition/intuition.h>
#include <graphics/gfxbase.h>
#include <functions.h>

#define ENTRIES 26
#define BACKSPACE ENTRIES
#define FORM_FEED ENTRIES+1
#define CR_ONLY   ENTRIES+2
#include "main.h"

long *IntuitionBase=0,*GfxBase=0;
struct Window *Window,*MessageWindow;
struct RastPort *rport,*mrport;

FILE *rf,*wf;
int count=0,iterations[ENTRIES+3],read_dir=0,dir_only=0,nb=0;
int windowtopedge,windowleftedge,doit[ENTRIES+3];

int codes[] = {
	99,64,65,66,67,68,69,70,72,74,75,76,77,80,83,84,104,108,109,110,
	112,113,116,117,120,121
	};

char *cnames[] = {
	"RESET TO INITIAL STATE",
	"INSERT [N] CHARACTERS",
	"CURSOR UP [N] CHARACTERS",
	"CURSOR DOWN [N] CHARACTERS",
	"CURSOR FWD [N] CHARACTERS",
	"CURSOR BKWD [N] CHARACTERS",
	"CURSOR NEXT LINE [N]",
	"CURSOR PRECEDING LINE [N]",
	"MOVE CURSOR TO ROW/COLUMN",
	"ERASE TO END OF DISPLAY",
	"ERASE TO END OF LINE",
	"INSERT LINE",
	"DELETE LINE",
	"DELETE CHARACTER [N]",
	"SCROLL UP [N] LINES",
	"SCROLL DOWN [N] LINES",
	"SET LINEFEED MODE",
	"RESET NEWLINE MODE",
	"SELECT GRAPHIC RENDITION",
	"DEVICE STATUS REPORT",
	"SET CURSOR RENDITION",
	"WINDOW STATUS REQUEST",
	"SET PAGE LENGTH",
	"SET LINE LENGTH",
	"SET LEFT OFFSET",
	"SET TOP OFFSET",
	"BACKSPACE",
	"FORM FEED",
	"CARRIAGE RETURN"
	};
char filename[128],pattern[40],title[25],path[75],mytitle[30],mypattern[10],oldcode[80],file1[128],file2[128];

main()
{
int i,exit_flag=0;
char c;
struct IntuiMessage *message;
ULONG class;

filename[0]='\0';

openstuff();

do {
	WaitPort(Window->UserPort);
		while ( ( message=(struct IntuiMessage *)
			GetMsg(Window->UserPort) ) != NULL)
		{
		class=message->Class;
		ReplyMsg(message); 

		if (class==GADGETUP) option(message);
		if (class==MENUPICK) exit_flag=menu(message);
		if (class==CLOSEWINDOW) exit_flag=1;
		}
	} while (exit_flag==0);

closestuff();
}

#include "about.c"
#include "message.c"
#include "alert.c"
#include "pointer.c"
#include "report.h"

menu(message)
struct IntuiMessage *message;
{
int rv=0;

switch(MENUNUM(message->Code)) {
	case 0: rv=project(message);
		break;

	default: break;
	}
return(rv);
}

project(message)
struct IntuiMessage *message;
{
switch(ITEMNUM(message->Code)) {

	case 0: about();
		break;

	case 1: return(1);            /* quit */

	default: break;
	}
return(0);
}

option(message)
struct IntuiMessage *message;
{
struct Gadget *igad;
int gadgid;

igad=(struct Gadget *) message->IAddress;
gadgid=igad->GadgetID;

switch(gadgid) {
	case 10: reportonly();
		 break;

	case 20: go();
		 break;

	default: break;
	}
}

reportonly()
{
int x;
char c,bytecount[28],ansicount[24];

for (x=0; x<ENTRIES+3; x++)
	iterations[x]=0;

strcpy(mytitle,"Choose file for REPORT...");
strcpy(mypattern,"#?");
x=getfile(mytitle,mypattern);
if (x==FALSE) return();
rf=fopen(filename,"rb");

if (rf==0) {
	alert("Can't open file!");
	return();
	}

strcpy(file1,filename);
strcpy(file2,"N/A");

count=0; nb=0;
Message("              Working...");
SetPointer(MessageWindow,&BusyPointer,22,16,0,0);

do {
	c=getc(rf); nb++;
	if(!(feof(rf))) {
	if (c=='\0x9b' || c==27) countcode();  /* either CSI or ESC */
	else if (c == 8) {
			count++;
			iterations[BACKSPACE]++;
			}
	else if (c == 12) {
			count++;
			iterations[FORM_FEED]++;
			}
	else if (c == 13) {
			count++;
			iterations[CR_ONLY]++;
			}
		}
	} while(!(feof(rf)));
nb--;
fclose(rf);
ClearPointer(MessageWindow);
CloseWindow(MessageWindow);
report();
}

countcode()
{
int i,exit_flag=0;
char c;

do {
	c=getc(rf); nb++;
	for (i=0; i<ENTRIES; i++) { 
		if (c==codes[i]) {
			exit_flag=1;
			iterations[i]++;
			count++;
			}
		}
	} while (exit_flag==0) ;
}

go()
{
int x;

for (x=0; x<ENTRIES+3; x++)
	iterations[x]=0;

filename[0]='\0';
strcpy(mytitle,"Choose SOURCE file...");
strcpy(mypattern,"#?");
x=getfile(mytitle,mypattern);
if (x==FALSE) return();

strcpy(file1,filename);

filename[0]='\0';
strcpy(mytitle,"Choose DESTINATION file...");
strcpy(mypattern,"#?");
if(!(stdfile("Choose DESTINATION file...",NULL,"#?",filename))) return();

strcpy(file2,filename);

if(!(rf=fopen(file1,"rb"))) {
	alert("Can't open SOURCE!");	
	return();
	}

if(!(wf=fopen(file2,"wb"))) {
	fclose(rf);		/* don't forget this! */
	alert("Can't open DEST!");
	return();
	}

count=0; nb=0;
Message("              Working...");
SetPointer(MessageWindow,&BusyPointer,22,16,0,0);

processgadgets();

readfile();

ClearPointer(MessageWindow);
CloseWindow(MessageWindow);
report();
}

readfile()
{
char c;

do {
	c=getc(rf); nb++;
	if(!(feof(rf))) {
	if (c=='\0x9b' || c==27) stripcode(c);  /* either CSI or ESC */
	else if (c == 8) {
		if (doit[BACKSPACE]) fputc(c,wf);
		else {
			iterations[BACKSPACE]++;	
			count++;
			}
		}
	else if (c == 12) {
		if (doit[FORM_FEED]) fputc(c,wf);
		else {
			iterations[FORM_FEED]++;
			count++;
			}
		}
	else if (c == 13) {
		if (doit[CR_ONLY]) fputc(c,wf);
		else {
			iterations[CR_ONLY]++;
			count++;
			}
		}
	else fputc(c,wf);
		}
	} while(!(feof(rf)));
nb--;
fclose(rf);
fclose(wf);	
}

stripcode(csi)
char csi;
{
int i,num=1,exit_flag=0;
char c;

oldcode[0]=csi;

do {
	c=getc(rf); oldcode[num++]=c; nb++;
	for (i=0; i<ENTRIES; i++) { 
		if (c==codes[i]) {
			exit_flag=1;
			if (doit[i]) putback(num);
			else {
				iterations[i]++;
				count++;
				}
			}
		}
	} while (exit_flag==0) ;
}

putback(num)
int num;
{
int i;

for (i=0; i<num; i++)
	fputc(oldcode[i],wf);
}

report()
{
struct IntuiMessage *message;
struct Window *RWindow;
struct RastPort *rrport;
ULONG class;
int x,y,i,report_exit=0;
char string[35];

if (count==0) return();

ReportWin.TopEdge=Window->TopEdge;
ReportWin.LeftEdge=Window->LeftEdge;

if(!(RWindow=OpenWindow(&ReportWin))) {
	alert("Couldn't open Window!");
	return();
	}

rrport=RWindow->RPort;
x=y=i=0;

SetAPen(rrport,3); SetBPen(rrport,0);
Move(rrport,3,18); Text(rrport,"SOURCE: ",8);
SetAPen(rrport,2);
sprintf(string,"%-30s",file1);
Text(rrport,string,30);
Move(rrport,330,18); SetAPen(rrport,3);
Text(rrport,"DEST: ",6);
sprintf(string,"%-30s",file2);
SetAPen(rrport,2);
Text(rrport,string,30);
SetAPen(rrport,3); Move(rrport,3,28);
Text(rrport,"# of ANSI Codes: ",17);
sprintf(string,"%-6d",count);
SetAPen(rrport,2);
Text(rrport,string,6);
SetAPen(rrport,3); Move(rrport,282,28);
Text(rrport,"# of bytes: ",12);
sprintf(string,"%-8d",nb);
SetAPen(rrport,2);
Text(rrport,string,8);

while (i<ENTRIES+3) {
		SetAPen(rrport,3); SetBPen(rrport,0);
		Move(rrport,x*320+3,y*9+43);
		sprintf(string,"%27s: ",cnames[i]);
		Text(rrport,string,29);
		SetAPen(rrport,1);
		sprintf(string,"%5d %3d%%",iterations[i],iterations[i]*100/count);
		Text(rrport,string,10);
		y++;
		if (y > 14) {
			y=0;
			x++;
			}
	i++;
	}
		
do {
	WaitPort(RWindow->UserPort);
		while ( ( message=(struct IntuiMessage *)
			GetMsg(RWindow->UserPort) ) != NULL)
		{
		class=message->Class;
		ReplyMsg(message); 

		if (class==GADGETUP) report_exit=1;
		}
	} while (report_exit==0);

CloseWindow(RWindow);
}

processgadgets()
{
int i;

for (i=0; i<ENTRIES+3; i++)
	doit[i]=0;

/* NOTE: I could have put these gadgets in an array, and it would have
	made life easier here, but since I wanted to use PowerWindows,
	I left it this way ... I know it sucks but oh well! What'ya gonna
	do? */

if (Gadget1.Flags & SELECTED) doit[0]=1;
if (Gadget2.Flags & SELECTED) doit[1]=1;
if (Gadget3.Flags & SELECTED) doit[2]=1;
if (Gadget4.Flags & SELECTED) doit[3]=1;
if (Gadget5.Flags & SELECTED) doit[4]=1;
if (Gadget6.Flags & SELECTED) doit[5]=1;
if (Gadget7.Flags & SELECTED) doit[6]=1;
if (Gadget8.Flags & SELECTED) doit[7]=1;
if (Gadget9.Flags & SELECTED) doit[8]=1;
if (Gadget10.Flags & SELECTED) doit[9]=1;
if (Gadget11.Flags & SELECTED) doit[10]=1;
if (Gadget12.Flags & SELECTED) doit[11]=1;
if (Gadget13.Flags & SELECTED) doit[12]=1;
if (Gadget14.Flags & SELECTED) doit[13]=1;
if (Gadget15.Flags & SELECTED) doit[14]=1;
if (Gadget16.Flags & SELECTED) doit[15]=1;
if (Gadget17.Flags & SELECTED) doit[16]=1;
if (Gadget18.Flags & SELECTED) doit[17]=1;
if (Gadget19.Flags & SELECTED) doit[18]=1;
if (Gadget20.Flags & SELECTED) doit[19]=1;
if (Gadget21.Flags & SELECTED) doit[20]=1;
if (Gadget22.Flags & SELECTED) doit[21]=1;
if (Gadget23.Flags & SELECTED) doit[22]=1;
if (Gadget24.Flags & SELECTED) doit[23]=1;
if (Gadget25.Flags & SELECTED) doit[24]=1;
if (Gadget26.Flags & SELECTED) doit[25]=1;
if (Gadget27.Flags & SELECTED) doit[26]=1;
if (Gadget28.Flags & SELECTED) doit[27]=1;
if (Gadget29.Flags & SELECTED) doit[28]=1;
}

getfile(titl,path)
char *titl,*path;
{
	windowtopedge=Window->TopEdge;
	windowleftedge=Window->LeftEdge;
	while(stdfile(titl, filename, path, filename)) {
		BPTR stdlock;
		struct FileInfoBlock *stdfib;
		FILE *fp;
		int c;

		stdfib = AllocMem(sizeof(struct FileInfoBlock), MEMF_PUBLIC);
		if(!stdfib) {
			alert(" Out of memory!");
			break;
		}

		if(!(stdlock = Lock(filename, ACCESS_READ))) {
			alert(" Can't obtain lock.");
			FreeMem(stdfib, sizeof(struct FileInfoBlock));
			continue;
		}
		if(!(Examine(stdlock, stdfib)) && dir_only==0) {
			alert("Can't examine file.");
			UnLock(stdlock);
			FreeMem(stdfib, sizeof(struct FileInfoBlock));
			continue;
		}
		UnLock(stdlock);

		if(stdfib->fib_DirEntryType >= 0 && dir_only==0) {
			alert("That's a directory.");
			FreeMem(stdfib, sizeof(struct FileInfoBlock));
			continue;
			}
		if(!(fp = fopen(filename, "r")) && dir_only==0) {
			perror(filename);
			FreeMem(stdfib, sizeof(struct FileInfoBlock));
			fclose(fp);
			continue;
			}
		FreeMem(stdfib, sizeof(struct FileInfoBlock));
		if (fp) fclose(fp);
		return(TRUE);
		break;
	}
	return(FALSE);
}

openstuff()
{
if((IntuitionBase=OpenLibrary("intuition.library",0L))==NULL)
	exit(1);
if((GfxBase=OpenLibrary("graphics.library",0L))==NULL)
	exit(1);

if (!(Window=OpenWindow(&NewWindowStructure1))) {
	closestuff();
	exit(1);
	}

rport=Window->RPort;
PrintIText(rport,&IntuiTextList1,0,0);
DrawBorder(rport,&BorderList1,0,0);
SetMenuStrip(Window,&MenuList1);
}

closestuff()
{
if (Window) ClearMenuStrip(Window);
if (Window) CloseWindow(Window);
if (IntuitionBase) CloseLibrary(IntuitionBase);
if (GfxBase) CloseLibrary(GfxBase);
}
